<!DOCTYPE html>
<html lang="en">

<head>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1">
    <title>Task 45.40 - Danh sách người dùng đăng ký</title>

    <!-- Google Font: Source Sans Pro -->
    <link rel="stylesheet"
        href="https://fonts.googleapis.com/css?family=Source+Sans+Pro:300,400,400i,700&display=fallback">
    <!-- Font Awesome -->
    <link rel="stylesheet" href="plugins/fontawesome-free/css/all.min.css">
    <!-- Theme style -->
    <link rel="stylesheet" href="dist/css/adminlte.min.css">
    <!-- Import Datatable sau jquery -->
    <!-- Import them style bootstrap cho datatable -->
    <link rel="stylesheet" href="https://cdn.datatables.net/1.10.24/css/dataTables.bootstrap4.min.css">
</head>

<body class="hold-transition sidebar-mini layout-fixed">
    <div class="wrapper">
        <!-- Navbar -->
        <nav class="main-header navbar navbar-expand navbar-white navbar-light">
            <!-- Left navbar links -->
            <ul class="navbar-nav">
                <li class="nav-item">
                    <a class="nav-link" data-widget="pushmenu" href="#" role="button"><i class="fas fa-bars"></i></a>
                </li>
                <li class="nav-item d-none d-sm-inline-block">
                    <a href="#" class="nav-link">User List</a>
                </li>
            </ul>

            <!-- Right navbar links -->
            <ul class="navbar-nav ml-auto">
                <li class="nav-item">
                    <a class="nav-link" data-widget="fullscreen" href="#" role="button">
                        <i class="fas fa-expand-arrows-alt"></i>
                    </a>
                </li>

            </ul>
        </nav>
        <!-- /.navbar -->
        <!-- Main Sidebar Container -->
        <aside class="main-sidebar sidebar-dark-primary elevation-4">
            <!-- Brand Logo -->
            <a href="#" class="brand-link">
                <span class="brand-text font-weight-light">Devcamp</span>
            </a>

            <!-- Sidebar -->
            <div class="sidebar">
                <!-- Sidebar Menu -->
                <nav class="mt-2">
                    <ul class="nav nav-pills nav-sidebar flex-column" data-widget="treeview" role="menu"
                        data-accordion="false">
                        <!-- Add icons to the links using the .nav-icon class
         with font-awesome or any other icon font library -->
                        <li class="nav-item menu-open">
                            <a href="#" class="nav-link active">
                                <i class="nav-icon fas fa-tachometer-alt"></i>
                                <p>
                                    Dashboard
                                    <i class="right fas fa-angle-left"></i>
                                </p>
                            </a>
                            <ul class="nav nav-treeview">
                                <li class="nav-item">
                                    <a href="./index.html" class="nav-link active">
                                        <i class="far fa-circle nav-icon"></i>
                                        <p>Dashboard v1</p>
                                    </a>
                                </li>
                                <li class="nav-item">
                                    <a href="./index2.html" class="nav-link">
                                        <i class="far fa-circle nav-icon"></i>
                                        <p>Dashboard v2</p>
                                    </a>
                                </li>
                                <li class="nav-item">
                                    <a href="./index3.html" class="nav-link">
                                        <i class="far fa-circle nav-icon"></i>
                                        <p>Dashboard v3</p>
                                    </a>
                                </li>
                            </ul>
                        </li>
                        <li class="nav-item">
                            <a href="pages/widgets.html" class="nav-link">
                                <i class="nav-icon fas fa-th"></i>
                                <p>
                                    Widgets
                                    <span class="right badge badge-danger">New</span>
                                </p>
                            </a>
                        </li>
                    </ul>
                </nav>
                <!-- /.sidebar-menu -->
            </div>
            <!-- /.sidebar -->
        </aside>
        <!-- Content Wrapper. Contains page content -->
        <div class="content-wrapper">
            <!-- Content Header (Page header) -->
            <div class="content-header">
                <div class="container-fluid">
                    <div class="row mb-2">
                        <div class="col-sm-6">
                            <h1 class="m-0">Danh sách người dùng đăng ký</h1>
                        </div><!-- /.col -->
                        <div class="col-sm-6">
                            <ol class="breadcrumb float-sm-right">
                                <li class="breadcrumb-item"><a href="#">Home</a></li>
                                <li class="breadcrumb-item active"> User list</li>
                            </ol>
                        </div><!-- /.col -->
                    </div><!-- /.row -->
                </div><!-- /.container-fluid -->
            </div>
            <!-- /.content-header -->
            <!-- Main content -->
            <section class="content">
                <div class="container-fluid">
                    <button class="btn btn-success form-group" id="btn-add-user" data-toggle='modal'
                        data-target='#insert-user-modal'> Thêm User </button>
                    <table class="table table-bordered table-striped table-hover text-center" id="user-table">
                        <thead>
                            <tr>
                                <th>Id</th>
                                <th>Firstname</th>
                                <th>Lastname</th>
                                <th>Country</th>
                                <th>Subject</th>
                                <th>Customer Type</th>
                                <th>Register Status</th>
                                <th>Action</th>
                            </tr>
                        </thead>
                        <tbody>
                        </tbody>
                    </table>
                    <!-- Vùng Modal -->

                    <!-- Create user modal -->
                    <div id="insert-user-modal" class="modal fade" tabindex="-1">
                        <div class="modal-dialog">
                            <div class="modal-content">
                                <!--modal header-->
                                <div class="modal-header">
                                    <h5 class="modal-title">Thêm User</h5>
                                    <button type="button" class="close" data-dimiss="modal">&times;</button>
                                </div>
                                <!--modal body-->
                                <div class="modal-body">
                                    <form>
                                        <div class="row form-group">
                                            <div class="col-sm-4">
                                                <label>First name</label>
                                            </div>
                                            <div class="col-sm-8">
                                                <input class="form-control" id="inp-firstname">
                                            </div>
                                        </div>
                                        <div class="row form-group">
                                            <div class="col-sm-4">
                                                <label>Last name</label>
                                            </div>
                                            <div class="col-sm-8">
                                                <input class="form-control" id="inp-lastname">
                                            </div>
                                        </div>
                                        <div class="row form-group">
                                            <div class="col-sm-4">
                                                <label>Subject</label>
                                            </div>
                                            <div class="col-sm-8">
                                                <input class="form-control" id="inp-subject">
                                            </div>
                                        </div>
                                        <div class="row form-group">
                                            <div class="col-sm-4">
                                                <label>Country</label>
                                            </div>
                                            <div class="col-sm-8">
                                                <select class="form-control" id="select-country">
                                                    <option value="NOT_SELECT_COUNTRY">Select Country</option>
                                                    <option value="VN">Việt Nam</option>
                                                    <option value="USA">USA</option>
                                                    <option value="AUS">Australia</option>
                                                    <option value="CAN">Canada</option>
                                                </select>
                                            </div>
                                        </div>
                                    </form>
                                </div>
                                <!-- modal-footer -->
                                <div class="modal-footer">
                                    <button class="btn btn-success" id="btn-create-user">Insert User</button>
                                    <button class="btn btn-secondary" data-dimiss="modal">Cancel</button>
                                </div>
                            </div>
                        </div>
                    </div>
                    <!-- Update User Modal -->
                    <div>
                        <div id="update-user-modal" class="modal fade" tabindex="-1">
                            <div class="modal-dialog">
                                <div class="modal-content">
                                    <div class="modal-header">
                                        <h5 class="modal-title" id="h5-modal-title">Update A User</h5>
                                        <button class="close" data-dismiss="modal">&times;</button>
                                    </div>
                                    <div class="modal-body">
                                        <form>
                                            <div class="row form-group">
                                                <div class="col-sm-4">
                                                    <label for="input-first-name"> Firstname </label>
                                                </div>
                                                <div class="col-sm-8">
                                                    <input type="text" id="input-first-name" name="firstName"
                                                        placeholder="Firstname" class="form-control">
                                                </div>
                                            </div>
                                            <div class="row form-group">
                                                <div class="col-sm-4">
                                                    <label for="input-last-name">Lastname</label>
                                                </div>
                                                <div class="col-sm-8">
                                                    <input type="text" id="input-last-name" name="lastName"
                                                        placeholder="Lastname" class="form-control">
                                                </div>
                                            </div>
                                            <div class="row form-group">
                                                <div class="col-sm-4">
                                                    <label for="input-subject">Subject</label>
                                                </div>
                                                <div class="col-sm-8">
                                                    <input type="text" id="input-subject" name="subject"
                                                        placeholder="Subject" class="form-control">
                                                </div>
                                            </div>
                                            <div class="row form-group">
                                                <div class="col-sm-4">
                                                    <label>Country</label>
                                                </div>
                                                <div class="col-sm-8">
                                                    <select class="form-control" id="select-country-origin">
                                                        <option value="NOT_SELECT_COUNTRY">Select Country</option>
                                                        <option value="VN">Việt Nam</option>
                                                        <option value="USA">USA</option>
                                                        <option value="AUS">Australia</option>
                                                        <option value="CAN">Canada</option>
                                                    </select>
                                                </div>
                                            </div>
                                            <div class="row form-group">
                                                <div class="col-sm-4">
                                                    <label>Customer Type</label>
                                                </div>
                                                <div class="col-sm-8">
                                                    <select class="form-control" id="select-customer-type">
                                                        <option value="NOT_SELECT_CUSTOMER_TYPE">Select Customer Type
                                                        </option>
                                                        <option value="Standard">Standard</option>
                                                        <option value="Gold">Gold</option>
                                                        <option value="Premium">Premium</option>
                                                    </select>
                                                </div>
                                            </div>
                                            <div class="row form-group">
                                                <div class="col-sm-4">
                                                    <label>Register Status</label>
                                                </div>
                                                <div class="col-sm-8">
                                                    <select class="form-control" id="select-register-status">
                                                        <option value="NOT_SELECT_REGISTER_STATUS">Select Register
                                                            Status</option>
                                                        <option value="Accepted">Accepted</option>
                                                        <option value="Denied">Denied</option>
                                                        <option value="Standard">Standard</option>
                                                    </select>
                                                </div>
                                            </div>
                                        </form>
                                    </div>
                                    <div class="modal-footer">
                                        <button class="btn btn-primary" id="btn-update-user">Update User</button>
                                        <button class="btn btn-secondary" id="btn-update-cancel"
                                            data-dismiss="modal">Cancel</button>
                                    </div>
                                </div>
                            </div>
                        </div>
                    </div>
                    <!-- Delete confirm modal -->
                    <div>
                        <div class="modal fade" tabindex="-1" id="delete-confirm-modal">
                            <div class="modal-dialog">
                                <div class="modal-content">
                                    <div class="modal-header">
                                        <h5 class="modal-title" id="h5-modal-title">User Delete Confirmation</h5>
                                        <button class="close" data-dismiss="modal">&times;</button>
                                    </div>
                                    <div class="modal-body">
                                        <label>Bạn có chắc chắn muốn xóa user này không?</label>
                                    </div>
                                    <div class="modal-footer">
                                        <button class="btn btn-danger" id="btn-confirm-delete-user">Confirm</button>
                                        <button class="btn btn-secondary" data-dismiss="modal">Cancel</button>
                                    </div>
                                </div>
                            </div>
                        </div>
                    </div>
                    <!-- Vùng Modal -->
                </div><!-- /.container-fluid -->
            </section>
        </div>
        <!-- /.content -->
        <!-- /.content-wrapper -->
        <footer class="main-footer">
            <strong>Copyright &copy; 2022 Devcamp</strong>
            All rights reserved.
            <div class="float-right d-none d-sm-inline-block">
                <b>Version</b> 1.0.0
            </div>
        </footer>
        <!-- jQuery -->
        <script src="plugins/jquery/jquery.min.js"></script>
        <!-- Bootstrap 4 -->
        <script src="plugins/bootstrap/js/bootstrap.bundle.min.js"></script>
        <!-- AdminLTE App -->
        <script src="dist/js/adminlte.js"></script>
        <script src="https://cdn.datatables.net/1.10.24/js/jquery.dataTables.min.js"></script>
        <script src="https://cdn.datatables.net/1.10.24/js/dataTables.bootstrap4.min.js"></script>

        <script>
            "use strict";
            /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
            //Biến toàn cục để lưu trữ id đang được update or delete. Mặc định = 0;
            var gUserId = 0;
            //Khai báo biến hằng số
            const gNOT_SELECT_COUNTRY = "NOT_SELECT_COUNTRY"; //giá trị value khi chưa chọn country
            var gCountryObjects = [
                {
                    "value": "VN",
                    "text": "Việt Nam"
                },
                {
                    "value": "USA",
                    "text": "USA"
                },
                {
                    "value": "AUS",
                    "text": "Australia"
                },
                {
                    "value": "CAN",
                    "text": "Canada"
                }
            ];
            const gNOT_SELECT_CUSTOMER_TYPE = "NOT_SELECT_CUSTOMER_TYPE"; //giá trị value khi chưa chọn customerType
            var gCustomerTypeObjects = [
                {
                    "value": "Standard",
                    "text": "Standard"
                },
                {
                    "value": "Gold",
                    "text": "Gold"
                },
                {
                    "value": "Premium",
                    "text": "Premium"
                }
            ];
            const gNOT_SELECT_REGISTER_STATUS = "NOT_SELECT_REGISTER_STATUS"; //giá trị value khi chưa chọn register status
            var gRegisterStatusObjects = [
                {
                    "value": "Accepted",
                    "text": "Accepted"
                },
                {
                    "value": "Denied",
                    "text": "Denied"
                },
                {
                    "value": "Standard",
                    "text": "Standard"
                }
            ];
            var gUserObjs = {
                firstname: "",
                lastname: "",
                subject: "",
                country: "",
            };

            //Khai báo biến mảng hằng số chứa danh sách tên các thuộc tính
            const gUSER_COLS = ["id", "firstname", "lastname", "country", "subject", "customerType", "registerStatus", "action"];
            //Biến mảng toàn cục định nghĩa chỉ số các cột tương ứng
            const gUSER_ID_COL = 0;
            const gUSER_FIRSTNAME_COL = 1;
            const gUSER_LASTNAME_COL = 2;
            const gUSER_COUNTRY_COL = 3;
            const gUSER_SUBJECT_COL = 4;
            const gUSER_CUSTOMER_TYPE_COL = 5;
            const gUSER_REGISTER_STATUS_COL = 6;
            const gUSER_ACTION_COL = 7;
            //Đổ dữ liệu vào bảng và thực hiện nút Sửa (Edit), Xoá (Delete)
            var gUserTable = $("#user-table").DataTable({
                columns: [
                    { data: gUSER_COLS[gUSER_ID_COL] },
                    { data: gUSER_COLS[gUSER_FIRSTNAME_COL] },
                    { data: gUSER_COLS[gUSER_LASTNAME_COL] },
                    { data: gUSER_COLS[gUSER_COUNTRY_COL] },
                    { data: gUSER_COLS[gUSER_SUBJECT_COL] },
                    { data: gUSER_COLS[gUSER_CUSTOMER_TYPE_COL] },
                    { data: gUSER_COLS[gUSER_REGISTER_STATUS_COL] },
                    { data: gUSER_COLS[gUSER_ACTION_COL] },
                ],
                columnDefs: [
                    {
                        //Định nghĩa lại cột Country
                        targets: gUSER_COUNTRY_COL,
                        render: function (data) {
                            return getCountryTextByCountryValue(data);
                        }
                    },
                    {
                        //Định nghĩa lại cột Action
                        targets: gUSER_ACTION_COL,
                        className: "text-center",
                        defaultContent: `
                        <button class="btn btn-primary btn-edit">Sửa</button>
                        <button class="btn btn-danger btn-delete" data-toggle='modal'>Xoá</button>
                        `
                    }
                ],
                autoWidth: false
            });
            //Khai  báo biến mảng chứa dữ liệu users
            var gListUsers = [];
            /*** REGION 2 - Vùng gán / thực thi sự kiện cho các elements */
            $(document).ready(function () {
                onPageLoading();
                // 2 - C: gán sự kiện Create - Thêm mới user
                $("#btn-add-user").on("click", function () {
                    onBtnAddNewUserClick();
                });
                // 3 - U: gán sự kiện Update - Sửa 1 user
                $("#user-table").on("click", ".btn-edit", function () {
                    onBtnEditClick(this);
                });
                //4 - D: gán sự kiện Delete - Xoá 1 user
                $("#user-table").on("click", ".btn-delete", function () {
                    onBtnDeleteClick(this);
                });
                //Gán sự kiện khi nút Insert User được click
                $("#btn-create-user").on("click", function () {
                    onBtnCreateUserClick();
                });
                //Gán sự kiện cho nút Update User (trên Modal Edit)
                $("#btn-update-user").on("click", function () {
                    onBtnUpdateUserClick();
                });
                //Gán sự kiện cho nút Delete User
                $("#btn-confirm-delete-user").on("click", function () {
                    onBtnConfirmDeleteUserClick();
                });
            });

            /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
            function onPageLoading() {
                "use strict";
                getAllUsers();
                //1 - R: Read / Load user to DataTable
                loadDataToUserTable(gListUsers);
            }
            //Hàm xử lý sự kiện click nút sửa
            function onBtnEditClick(paramButtonElement) {
                "use strict";
                //Lưu thông tin Id đang được Edit vào biến toàn cục
                gUserId = getUserIdFromButton(paramButtonElement);
                //Load dữ liệu vào các trường dữ liệu trong modal
                showUserDataToModal(gUserId);
                //Hiển thị modal lên
                $("#update-user-modal").modal("show");
                //Ghi ra console
                console.log("Button Edit Click!!!");
                var vRowClick = $(paramButtonElement).closest("tr"); //xác định tr chứa nút bấm được click
                var vTable = $("#user-table").DataTable(); //tạo biến truy xuất đến datatable
                var vDataRow = vTable.row(vRowClick).data(); //lấy dữ liệu của hàng dữ liệu chứa nút bấm được click
                console.log("ID của user tương ứng = " + vDataRow.id);
            }
            // Hàm xử lý sự kiện khi icon delete user trên bảng được click
            function onBtnDeleteClick(paramButtonElement) {
                "use strict";
                console.log("Button Delete Click!!!");
                var vRowClick = $(paramButtonElement).closest("tr"); //xác định tr chứa nút bấm được click
                var vTable = $("#user-table").DataTable(); //tạo biến truy xuất đến datatable
                var vDataRow = vTable.row(vRowClick).data(); //lấy dữ liệu của hàng dữ liệu chứa nút bấm được click
                console.log("ID của user tương ứng = " + vDataRow.id);
                //lưu thông tin userId đang được edit vào biến toàn cục 
                gUserId = getUserIdFromButton(paramButtonElement);
                //Hiển thị modal lên 
                $("#delete-confirm-modal").modal("show");
            }
            //Hàm xử lý sự kiện khi nút Thêm mới được Click
            function onBtnAddNewUserClick() {
                //Hiển thị modal lên
                $("#create-user-modal").modal("show");
            }
            //Hàm xử lý sự kiện nút Insert User
            function onBtnCreateUserClick() {
                "use strict";
                //khai báo đối tượng chứa user data
                var vUserObj = {
                    firstname: "",
                    lastname: "",
                    subject: "",
                    country: ""
                };
                //B1: Thu thập dữ liệu
                getUserDataCreate(vUserObj);
                //B2: Validate insert
                var vIsUserValidate = validateInsertData(vUserObj);
                if (vIsUserValidate) {
                    //B3: insert user
                    postUserApi(vUserObj);
                    //B4: xử lý front-end
                    //Gọi API lấy danh sách user
                    getAllUsers();
                    //Load lại vào bảng (table)
                    loadDataToUserTable(gListUsers);
                    //Xoá trắng dữ liệu trên modal
                    resertCreateUserForm();
                    //Tắt (ẩn) modal form create user
                    $("#insert-user-modal").modal("hide");
                }
            }
            //Hàm xoá trắng form create user
            function resertCreateUserForm() {
                $("#inp-firstname").val("");
                $("#inp-lastname").val("");
                $("#inp-subject").val("");
                $("#select-country").val(gNOT_SELECT_COUNTRY);
            }
            //Hàm xử lý sự kiện Update User (trong Modal của nút Sửa)
            function onBtnUpdateUserClick() {
                //khai báo đối tượng chứa user data 
                var vUserObj = {
                    firstname: "",
                    lastname: "",
                    subject: "",
                    country: "",
                    customerType: "",
                    registerStatus: ""
                };
                //Bước 1: Thu thập dữ liệu
                getUpdateUserData(vUserObj);
                //Bước 2: Validate update
                var vIsUserValidate = validateUserData(vUserObj);
                if (vIsUserValidate) {
                    //Bước 3: Update User
                    updateUser(vUserObj);
                    //Bước 4: Xử lý Front-end
                    alert("Sửa user thành công!");
                    loadDataToUserTable(gListUsers);
                    resertUpdateUserForm();
                    $("#update-user-modal").modal("hide");
                }
            }
            //Hàm xoá trắng Update User (trên Modal Sửa)
            function resertUpdateUserForm() {
                $("#input-first-name").val("");
                $("#input-last-name").val("");
                $("#input-subject").val("");
                $("#select-country-origin").val("");
                $("#select-customer-type").val("");
                $("#select-register-status").val("");
            }
            //Hàm xử lý sự kiện nút "Confirm" trên Delete User Modal
            function onBtnConfirmDeleteUserClick() {
                //thu thập dữ liệu (không có)
                //validate dữ liệu (không có)
                //xoá user
                deleteUser(gUserId);
                //xử lý hiển thị front-end
                alert("Xoá User thành công!");
                loadDataToUserTable(gListUsers);
                $("#delete-confirm-modal").modal("hide");
            }
            /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/

            //Load user array to Datatable
            //in: user array
            //out: user table has data
            function loadDataToUserTable(paramUserArray) {
                gSTT = 1;
                gUserTable.clear();
                gUserTable.rows.add(paramUserArray);
                gUserTable.draw();
            }
            //Hàm thu thập dữ liệu để update user (trên Modal Sửa)
            function getUpdateUserData(paramUserObj) {
                paramUserObj.id = gUserId;
                paramUserObj.firstname = $("#input-first-name").val().trim();
                paramUserObj.lastname = $("#input-last-name").val().trim();
                paramUserObj.subject = $("#input-subject").val().trim();
                paramUserObj.country = $("#select-country-origin").val();
                paramUserObj.customerType = $("#select-customer-type").val();
                paramUserObj.registerStatus = $("#select-register-status").val();
            }

            //Hàm validate dữ liệu để update user (trên Modal Sửa)
            function validateUserData(paramUserObj) {
                if (paramUserObj.firstname == "") {
                    alert("[Firstname] không được để trống!");
                    return false;
                }
                if (paramUserObj.lastname == "") {
                    alert("[Lastname] không được để trống!");
                    return false;
                }
                if (paramUserObj.subject == "") {
                    alert("[Subject] không được để trống!");
                    return false;
                }
                if (paramUserObj.country == "") {
                    alert("[Country] không được để trống!");
                    return false;
                }
                if (paramUserObj.customerType == "") {
                    alert("[Customer Type] không được để trống!");
                    return false;
                }
                if (paramUserObj.registerStatus == "") {
                    alert("[Register Status] không được để trống!");
                    return false;
                }
                return true;
            }

            //Hàm update user vào mảng (trên Modal Sửa)
            function updateUser(paramUserObj) {
                var vUserIndex = getIndexFormUserId(gUserId);
                gListUsers.splice(vUserIndex, 1, paramUserObj);
            }

            //Hàm xoá user theo user Id 
            function deleteUser(paramUserId) {
                var vUserIndex = getIndexFormUserId(paramUserId);
                gListUsers.splice(vUserIndex, 1);
            }

            //Hàm lấy text country theo value của country
            function getCountryTextByCountryValue(paramCountry) {
                "use strict";
                var vTextCountry = "";
                for (var bI = 0; bI < gCountryObjects.length; bI++) {
                    if (gCountryObjects[bI].value == paramCountry) {
                        vTextCountry = gCountryObjects[bI].text;
                    }
                };
                return vTextCountry;
            }
            //Hàm gọi API lấy danh sách user
            function getAllUsers() {
                "use strict";
                $.ajax({
                    async: false,
                    url: "http://42.115.221.44:8080/crud-api/users/",
                    type: "GET",
                    dataType: "json",
                    success: function (res) {
                        //lấy response trả về và gán cho biến gListUsers
                        gListUsers = res;
                    },
                    error: function (error) {
                        console.log(error.responseText);
                    }
                })
            }
            /** Load người dùng vào DataTable
             * input/start: 
             * output /end: hiện dữ liệu người dùng vào bảng
             */
            function loadDataToUserTable(paramObjectUsers) {
                console.log(paramObjectUsers);
                var vTable = $("#user-table").DataTable();
                vTable.clear();
                vTable.rows.add(paramObjectUsers);
                vTable.draw();
            }
            //Hàm thu thập dữ liệu để Insert User
            function getUserDataCreate(paramUserObj) {
                "use strict";
                paramUserObj.firstname = $("#inp-firstname").val().trim();
                paramUserObj.lastname = $("#inp-lastname").val().trim();
                paramUserObj.subject = $("#inp-subject").val().trim();
                paramUserObj.country = $("#select-country").val().trim();
            }
            //Hàm validate data khi insert
            function validateInsertData(paramUserObj) {
                "use strict";
                if (paramUserObj.firstname == "") {
                    alert("Firstname cần nhập");
                    return false;
                };
                if (paramUserObj.lastname == "") {
                    alert("Lastname cần nhập");
                    return false;
                };
                if (paramUserObj.subject == "") {
                    alert("Subject cần nhập");
                    return false;
                };
                if (paramUserObj.country == gNOT_SELECT_COUNTRY) {
                    alert("Country cần chọn");
                    return false;
                };
                return true;
            }
            //Hàm gọi API Insert User
            function postUserApi(paramUserObj) {
                "use strict";
                $.ajax({
                    async: false,
                    url: "http://42.115.221.44:8080/crud-api/users/",
                    type: "POST",
                    data: JSON.stringify(paramUserObj),
                    contentType: "application/json",
                    success: function (res) {
                        console.log(res);
                        alert("Thêm user thành công!");
                    },
                    error: function (error) {
                        alert(error.responseText);
                    }
                });
            }
            /* get user index from user id
            // input: paramUserId là userId cần tìm index
            /  output: trả về chỉ số (index) trong mảng user */
            function getIndexFormUserId(paramUserId) {
                var vUserIndex = -1;
                var vUserFound = false;
                var vLoopIndex = 0;
                while (!vUserFound && vLoopIndex < gListUsers.length) {
                    if (gListUsers[vLoopIndex].id === paramUserId) {
                        vUserIndex = vLoopIndex;
                        vUserFound = true;
                    }
                    else {
                        vLoopIndex++;
                    }
                }
                return vUserIndex;
            }

            //Hàm dựa vào button detail (edit or delete) xác định được id user
            function getUserIdFromButton(paramButton) {
                var vTableRow = $(paramButton).parents("tr");
                var vUserRowData = gUserTable.row(vTableRow).data();
                return vUserRowData.id;
            }
            //Hàm show user object lên modal
            function showUserDataToModal(paramUserId) {
                console.log(paramUserId);
                var vUserIndex = getIndexFormUserId(paramUserId);
                console.log(vUserIndex);
                $("#input-first-name").val(gListUsers[vUserIndex].firstname);
                $("#input-last-name").val(gListUsers[vUserIndex].lastname);
                $("#input-subject").val(gListUsers[vUserIndex].subject);
                $("#select-country-origin").val(gListUsers[vUserIndex].country);
                $("#select-customer-type").val(gListUsers[vUserIndex].customerType);
                $("#select-register-status").val(gListUsers[vUserIndex].registerStatus);

            }

        </script>

</body>

</html>